Attribute VB_Name = "Module1"
' vb@rchiv - Das groe Visual-Basic Archiv
' Tools & Components - Entwicklerkomponenten fr VB-32 Bit
'
' Copyright 2000-2003 Dieter Otter
'
' Der Programmcode darf fr eigene Zwecke verwendet werden.
' Es ist nicht erlaubt Inhalte des Projektes ohne unserer
' Zustimmung zum Download anzubieten.
'
' Die Beispielskripte sind Computerprogramme, die gem
' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
' Schutz geniessen und drfen nicht fr eigene ausgegeben
' werden.
'
' Dieter Otter
' Software-Entwicklung & Vertrieb
' info@vbarchiv.de
' http://www.vbarchiv.de
' http://www.visualbasic-archiv.de
'
' info@tools4vb.de
' http://www.tools4vb.de
'======================================================
Option Explicit

' zunchst die bentigten API-Deklarationen
Private Declare Function GetFileVersionInfoSize Lib "version.dll" _
  Alias "GetFileVersionInfoSizeA" ( _
  ByVal lptstrFilename As String, _
  lpdwHandle As Long) As Long

Private Declare Function GetFileVersionInfo Lib "version.dll" _
  Alias "GetFileVersionInfoA" ( _
  ByVal lptstrFilename As String, _
  ByVal dwHandle As Long, _
  ByVal dwLen As Long, _
  lpData As Any) As Long

Public Type udtFileInfo
  CompanyName As String
  FileDescription As String
  FileVersion As String
  InternalName As String
  LegalCopyright As String
  OriginalFilename As String
  ProductName As String
  ProductVersion As String
  Comments As String
  LegalTrademarks As String
End Type
' Erweiterte Datei-Informationen auslesen
Public Function GetExtendedFileInfo(ByVal sFile As String) As udtFileInfo
  Dim nSize As Long
  Dim sBuffer As String
    
  ' zunchst Gre der FileInfo-Struktur ermitteln
  nSize = GetFileVersionInfoSize(sFile, 0&)
  If nSize = 0 Then
    ' Fehler oder keine FileInfos verfgbar
    Exit Function
  End If
  
  ' Buffer fr die Info-Daten bereitstellen
  ' und Daten auslesen
  sBuffer = Space$(nSize)
  If GetFileVersionInfo(sFile, 0&, nSize, ByVal StrPtr(sBuffer)) = 0 Then
    ' Fehler!
    Exit Function
  End If
  
  ' Die Daten werden als String zurckgegeben, den wir jetzt noch
  ' extrahieren mssen
  With GetExtendedFileInfo
    .Comments = ExtractData(sBuffer, "Comments")
    .CompanyName = ExtractData(sBuffer, "CompanyName")
    .FileDescription = ExtractData(sBuffer, "FileDescription")
    .FileVersion = ExtractData(sBuffer, "FileVersion")
    .InternalName = ExtractData(sBuffer, "InternalName")
    .LegalCopyright = ExtractData(sBuffer, "LegalCopyright")
    .LegalTrademarks = ExtractData(sBuffer, "Trademarks")
    .OriginalFilename = ExtractData(sBuffer, "OriginalFilename")
    .ProductName = ExtractData(sBuffer, "ProductName")
    .ProductVersion = ExtractData(sBuffer, "ProductVersion")
  End With
End Function
' Hilfsfunktion
Private Function ExtractData(ByVal sBuffer As String, _
  ByVal sLookFor As String) As String

  Dim nPos As Long
  Dim sData As String
  
  nPos = InStr(sBuffer, Chr$(1) + sLookFor)
  If nPos > 0 Then
    sData = Mid$(sBuffer, nPos + Len(sLookFor) + 2)
    If Left$(sData, 1) = vbNullChar Then sData = Mid$(sData, 2)
    nPos = InStr(sData, vbNullChar)
    If nPos > 0 Then sData = Left$(sData, nPos - 1)
  End If
  
  ExtractData = sData
End Function


